// clock.cpp - fajl sa implementacijom svih funkcija clanica (metoda) klase Clock

// Ukljucivanje fajla clock.h i standardnih biblioteka za ulaz-izlaz i rad sa stringovima
#include "clock.h"
#include <iomanip>
#include <iostream>
using namespace std;

// Definicije funkcija clanica (metoda) klase Clock
void Clock::tick() {
	this->s++;						// pristup privatnom polju 's' objekta klase Clock za kojeg je ova metoda pozvana
	if (this->s == 60) this->s = 0, this->m++;	// sve promene nad poljima h, m, s u okviru metode vrse se nad OBJEKTOM nad kojim je
	if (this->m == 60) this->m = 0, this->h++;	// metoda pozvana jer se poljima pristupa preko pokazivaca 'this' koji ukazuje na objekat nad kojim je pozvana metoda
	if (this->h == 24) this->h = 0;
}

void Clock::setTime(int h, int m, int s) {
	this->h = (h >= 0 && h <= 23) ? h : 0;	// this->h - polje objekta nad kojim pozivamo metodu
	this->m = (m >= 0 && m <= 59) ? m : 0;	//		 h - parametar funkcije
	this->s = (s >= 0 && s <= 59) ? s : 0;
}

void Clock::printTime() {
	// setw - modifikator koji prvi sledeci podatak za ispis ispisuje na sirini od onoliko karaktera koliko je dato u argumentu modifikatora
	// setfill - modifikator koji prvi sledeci podatak dopunjava karakterom datim kao argument modifikatora do zadate sirine 
	cout << setw(2) << setfill('0') << this->h << ':'
		<< setw(2) << setfill('0') << this->m << ':'
		<< setw(2) << setfill('0') << this->s << endl;
	// cout == standardni izlaz .... endl == nov red
}

/*
	Konstruktor koji se poziva prilikom kreiranja objekta se automatski bira na osnovu
	parametara navedenih u okviru deklaracije promenljive objekta date klase
	npr: Clock *pClk = new Clock(); --> poziva se konstruktor bez parametara
		 Clock *pClk = new Clock(12, 50, 30) --> poziva se konstruktor koji prima tri integer vrednosti
		 itd.
*/

// Definicija konstruktora bez parametara
Clock::Clock() {
	// Inicijalizaciju objekta vrsimo pozivom vec implementirane metode setTime(...);
	setTime(0, 0, 0);
}

// Definicija konstruktora sa parametrima
Clock::Clock(int h, int m, int s) {
	setTime(h, m, s);
}