// clock.h - fajl sa definicijom same klase Clock, bez implementacije njenih funkcija clanica (metoda)

// Obezbedjivanje da se sadrzaj fajla clock.h ukljuci samo jednom
#ifndef _CLOCK_H_
#define _CLOCK_H_

// Ukljucivanje standardnih biblioteka za ulaz-izlaz i za rad sa stringovima
#include <iostream>
#include <string>
// Sledeca linija koda je potrebna da bi identifikatori iz prostora imena 'std' mogli da se pisu bez prefiksa 'std::'
using namespace std;

// Pocetak definicije klase Clock
class Clock {

	/* Kljucna rec 'public' oznacava da se svim clanovima klase (poljima i metodama) iza kljucne reci
	 moze pristupiti i van same klase */
public:

	/*  Konstruktori sluze sa pravilnu inicijalizaciju svih polja klase, kako bi pocetne vrednosti
		tih polja bile definisane odmah pri kreiranju objekta */
	Clock();
	Clock(int h, int m, int s);

	// Funkcije clanice (metode) klase Clock
	void tick();						// otkucaj jedne sekunde na satu
	void printTime();					// ispisuje trenutno vreme na satu na standardni izlaz
	void setTime(int h, int m, int s);		// postavlja vreme na satu na zeljenu vrednost

/* Kljucna rec 'private' oznacava da se svim clanovima klase (poljima i metodama) iza kljucne reci
 moze pristupiti iskljucivo u okviru definicija metoda date klase, a nikako van same klase
 Ovo pravo pristupa je podrazumevano pravo pristupa ukoliko se u klasi ne navede ni public ni private */
private:

	// Podaci clanovi (polja) klase Clock
	int h, m, s;								// h = hour, m = minute, s = second
												// cuvaju informacije o trenutnom vremenu na satu

}; // Kraj definicije klase Clock

#endif	// Kraj #ifndef _CLOCK_H_ direktive